function [g,h,dg,dh] = eval_functions_grad(u, dimu, N, x0, t0, A, b, c, rhs, rhs_x, rhs_u, lb, ub, Pl, Pu, statelb, stateub, hstep, target, grideps)

mPl = size(Pl, 1);
mPu = size(Pu, 1);
stages = size(A, 1);
dimx = size(x0, 1);

h  = zeros(N*dimx*(stages+1), 1);
dh = zeros(N*dimx*(stages+1), size(u,1));
g  = zeros(2*dimu*N+(mPl+mPu)*(N-1)+2*dimx, 1);
dg = zeros(2*dimu*N+(mPl+mPu)*(N-1)+2*dimx, size(u,1));

t = t0;
x = x0;

for i=1:N
    vertint = 2*dimu*(i-1) + (1:dimu);
	gidx = 2*dimu*N + (mPl+mPu)*(i-1);
    hidx = (i-1)*dimx*(stages+1)+(1:dimx);
    kidx = N*dimu+dimx*N+(i-1)*stages*dimx+(1:dimx);
    uidx = (i-1)*dimu+(1:dimu);
    ushootidx = N*dimu+(i-1)*dimx+(1:dimx);

	horizint = dimu*(i-1) + (1:dimu);

    for j=1:stages
        tempx = 0;
        for l=1:stages
            tempx = tempx + A(j,l).*u(kidx+(l-1)*dimx);
        end
        fx = rhs_x(t+c(j)*hstep, x+hstep.*tempx, u(uidx));
        fu = rhs_u(t+c(j)*hstep, x+hstep.*tempx, u(uidx));

        if i>1
            dh(hidx+(j-1)*dimx, ushootidx-dimx)=fx;
        end
        for l=1:stages
            if l==j
                dh(hidx+(j-1)*dimx, kidx+(l-1)*dimx) = fx.*hstep*A(j,l) - eye(dimx);
            else
                dh(hidx+(j-1)*dimx, kidx+(l-1)*dimx) = fx.*hstep*A(j,l);
            end
        end
        dh(hidx+(j-1)*dimx, uidx) = fu;
        h(hidx+(j-1)*dimx) = rhs(t + c(j)*hstep, x+hstep.*tempx, u(uidx)) - u(kidx+(j-1)*dimx);
    end

    tempx = 0;
    for l=1:stages
        tempx = tempx + b(l).*u(kidx+(l-1)*dimx);
        dh(hidx+stages*dimx, kidx+(l-1)*dimx) = eye(dimx).*hstep.*b(l);
    end
    h(hidx+stages*dimx) = x+hstep.*tempx - u(ushootidx);
    if i>1
        dh(hidx+stages*dimx, ushootidx-dimx) = eye(dimx);
    end
    dh(hidx+stages*dimx, ushootidx) = -eye(dimx);



	g(vertint) = (ub - u(uidx));
	g(vertint+dimu) = (u(uidx) - lb);
	dg(vertint, horizint) = -eye(dimu);
	dg(vertint+dimu, horizint) = eye(dimu);
	if i==N
		if mPu>0
			g(gidx+(1:dimx)) = Pu'*min([stateub, Pu*(target+grideps)],[],2) + (eye(dimx)-Pu'*Pu)*(grideps+target) - u(ushootidx);
		else
			g(gidx+(1:dimx)) = target+grideps - u(ushootidx);
		end
		if mPl>0
			g(gidx+dimx+(1:dimx)) = u(ushootidx) - (Pl'*max([statelb, Pl*(target-grideps)],[],2) + (eye(dimx)-Pl'*Pl)*(target-grideps));
		else
			g(gidx+dimx+(1:dimx)) = u(ushootidx) - (target-grideps);
		end

		dg(gidx+(1:dimx), ushootidx) = -eye(dimx);
		dg(gidx+dimx+(1:dimx), ushootidx) = eye(dimx);
	end

	if i < N
        if mPu>0
			g(gidx+(1:mPu)) = stateub - Pu*u(ushootidx);
			dg(gidx+(1:mPu),ushootidx)= -Pu;
        end
        if mPl>0
			g(gidx+mPu+(1:mPl)) = Pl*u(ushootidx) - statelb;
			dg(gidx+mPu+(1:mPl),ushootidx)=Pl;
        end

        x = u(ushootidx);
        t = t+hstep;
	end
end
